## libfplus 0.2.13

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

project(FunctionalPlus VERSION 0.2.13)

message(STATUS "===( ${PROJECT_NAME} ${PROJECT_VERSION} )===")
option(FPLUS_USE_TOOLCHAIN "Use compiler flags from an external toolchain" OFF)
option(FPLUS_BUILD_EXAMPLES "Build examples" ON)
option(FPLUS_BUILD_UNITTEST "Build unit tests" OFF)
option(FPLUS_UNITTEST_USE_CONAN "Use conan to get doctest dependency (for unit tests only)" OFF)

message(STATUS "Building Unit Tests ${FPLUS_BUILD_UNITTEST}")
message(STATUS "Use conan ${FPLUS_UNITTEST_USE_CONAN}")
message(STATUS "Building examples ${FPLUS_BUILD_EXAMPLES}")

if(NOT FPLUS_USE_TOOLCHAIN)
  if (MSVC)
    include(cmake/toolchain_msvc.cmake)
  else()
    include(cmake/toolchain.cmake)
  endif()
endif()

add_library(fplus INTERFACE)
add_library(FunctionalPlus::fplus ALIAS fplus)
target_include_directories(fplus INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/include>
  )

find_package(Threads REQUIRED)
target_link_libraries(fplus INTERFACE Threads::Threads)

add_subdirectory(include_all_in_one)

if(FPLUS_BUILD_UNITTEST)
    enable_testing()
    add_subdirectory(test)
endif()

if(FPLUS_BUILD_EXAMPLES)
    add_executable(readme_perf_examples EXCLUDE_FROM_ALL examples/readme_perf_examples.cpp)
    target_compile_options(readme_perf_examples PRIVATE ${COMPILE_OPTIONS})
    target_link_libraries(readme_perf_examples PRIVATE fplus ${CMAKE_THREAD_LIBS_INIT})

    add_executable(99_problems EXCLUDE_FROM_ALL examples/99_problems.cpp)
    target_compile_options(99_problems PRIVATE ${COMPILE_OPTIONS})
    target_link_libraries(99_problems PRIVATE fplus ${CMAKE_THREAD_LIBS_INIT})
endif()

# Run pkgconfig installation:
include(cmake/pkgconfig.cmake)

=== include_all_in_one/CMakeLists.txt ===
find_package (Python COMPONENTS Interpreter QUIET)
if (Python_FOUND)
    add_custom_target(
        include_all_in_one
        ALL
        COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_LIST_DIR}/make_all_in_one.py
    )
else()
    message(STATUS "Not generating include_all_in_one, python was not found.")
endif()

=== test/CMakeLists.txt ===
if (FPLUS_UNITTEST_USE_CONAN)
  # if using conan for the build, first install doctest via conan:
  # > cd build/
  # > conan install .. -obuild_unittest=True
  # > cmake .. -DFPLUS_BUILD_UNITTEST=ON -DFPLUS_UNITTEST_USE_CONAN=ON
  include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
  conan_basic_setup()
else()
    find_package(doctest CONFIG REQUIRED)
endif()

set(link_libraries fplus ${CMAKE_THREAD_LIBS_INIT})
if (NOT FPLUS_UNITTEST_USE_CONAN)
    list(APPEND link_libraries doctest::doctest)
endif()

function(add_test_suite name)
    add_executable(${name} ${name}.cpp)
    add_test(NAME ${name} COMMAND ${name})
    target_compile_options(${name} PRIVATE ${COMPILE_OPTIONS})
    target_link_libraries(${name} PRIVATE ${link_libraries})
endfunction()

add_test_suite(show_versions)
add_test_suite(benchmark_session_test)
add_test_suite(compare_test)
add_test_suite(composition_test)
add_test_suite(container_common_test)
add_test_suite(container_properties_test)
add_test_suite(container_traits_test)
add_test_suite(curry_test)
add_test_suite(extrapolate_test)
add_test_suite(filter_test)
add_test_suite(function_traits_test)
add_test_suite(fwd_test)
add_test_suite(generate_test)
add_test_suite(interpolate_test)
add_test_suite(invoke_test)
add_test_suite(maps_test)
add_test_suite(maybe_test)
add_test_suite(numeric_test)
add_test_suite(optimize_test)
add_test_suite(pairs_test)
add_test_suite(queue_test)
add_test_suite(raii_test)
add_test_suite(read_test)
add_test_suite(readme_examples_test)
add_test_suite(result_test)
add_test_suite(replace_test)
add_test_suite(search_test)
add_test_suite(sets_test)
add_test_suite(shared_ref_test)
add_test_suite(show_test)
add_test_suite(side_effects_test)
add_test_suite(split_test)
add_test_suite(stopwatch_test)
add_test_suite(stringtools_test)
add_test_suite(stringtools_utf8_test)
add_test_suite(stringtools_cp1251_test)
add_test_suite(stringtools_cp1253_test)
add_test_suite(transform_test)
add_test_suite(timed_test)
add_test_suite(tree_test)
add_test_suite(udemy_course_test)
add_test_suite(variant_test)

if(NOT MSVC)
    target_compile_options(stringtools_cp1251_test
        PRIVATE -Wno-invalid-source-encoding
    )
    target_compile_options(stringtools_cp1253_test
        PRIVATE -Wno-invalid-source-encoding
    )
    target_compile_options(stringtools_utf8_test
        PRIVATE -Wno-invalid-source-encoding
    )
endif()


add_custom_target(unittest show_versions
                        COMMAND benchmark_session_test
                        COMMAND compare_test
                        COMMAND composition_test
                        COMMAND container_common_test
                        COMMAND container_properties_test
                        COMMAND container_traits_test
                        COMMAND curry_test
                        COMMAND extrapolate_test
                        COMMAND filter_test
                        COMMAND function_traits_test
                        COMMAND fwd_test
                        COMMAND generate_test
                        COMMAND interpolate_test
                        COMMAND invoke_test
                        COMMAND maps_test
                        COMMAND maybe_test
                        COMMAND numeric_test
                        COMMAND optimize_test
                        COMMAND pairs_test
                        COMMAND queue_test
                        COMMAND raii_test
                        COMMAND read_test
                        COMMAND readme_examples_test
                        COMMAND result_test
                        COMMAND replace_test
                        COMMAND search_test
                        COMMAND sets_test
                        COMMAND shared_ref_test
                        COMMAND show_test
                        COMMAND side_effects_test
                        COMMAND split_test
                        COMMAND stopwatch_test
                        COMMAND stringtools_test
                        COMMAND stringtools_cp1251_test
                        COMMAND stringtools_cp1253_test
                        COMMAND stringtools_utf8_test
                        COMMAND timed_test
                        COMMAND transform_test
                        COMMAND tree_test
                        COMMAND udemy_course_test
                        COMMAND variant_test
                        COMMENT "Running unittests\n\n"
                        VERBATIM
                        )

=== test_package/CMakeLists.txt ===
project(test_package)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
conan_basic_setup()

add_executable(test_package test_package.cpp)
target_link_libraries(test_package ${CONAN_LIBS})

=== debian/changelog ===
libfplus (0.2.13-2) unstable; urgency=medium

  * Team upload.
  * Configure with -DCMAKE_POLICY_VERSION_MINIMUM=3.5 (Closes: #1113151)

 -- Andrius Merkys <merkys@debian.org>  Thu, 02 Oct 2025 02:43:25 -0400

libfplus (0.2.13-1) unstable; urgency=low

  * Initial release (Closes: #986239).

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 01 Apr 2021 12:08:45 +0200

=== debian/control ===
Source: libfplus
Section: devel
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper-compat (= 12),
 dh-exec (>= 0.3),
 dpkg-dev (>= 1.18.25),
 cmake,
 python3-docutils
Standards-Version: 4.5.1
Homepage: https://github.com/Dobiasd/FunctionalPlus
Vcs-Browser: https://salsa.debian.org/debichem-team/libfplus
Vcs-Git: https://salsa.debian.org/debichem-team/libfplus.git


Package: libfplus-dev
Section: libdevel
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Helps developers writing concise and readable C++ code (dev files)
 Great code should mostly be self-documenting, but while using C++ in reality
 you can find yourself dealing with low-level stuff like iterators or
 hand-written loops that distract from the actual essence of your code.
 . 
 FunctionalPlus is a small header-only library supporting you in reducing code
 noise and in dealing with only one single level of abstraction at a time. By
 increasing brevity and maintainability of your code it can improve
 productivity (and fun!) in the long run. It pursues these goals by providing
 pure and easy-to-use functions that free you from implementing commonly used
 flows of control over and over again.
 .
 This package ships this header-only library files.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_POLICY_VERSION_MINIMUM=3.5
	rst2man debian/libfplus.3.rst > debian/libfplus.3
